SystemOrganization addCategory: #Proxies!

ProtoObject subclass: #ClassProxyInstVar
	instanceVariableNames: 'superclass methodDict format actualClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:04'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 10/1/2010 14:57'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
	actualClass := self! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 15:56'!
restore
	self log: 'Will restore class'.
	self become: actualClass.
	self log: 'Class restored'.
! !

ProtoObject subclass: #CompiledMethodProxy
	instanceVariableNames: 'oldMethod reference executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 16:18'!
installOn: aClass selector: aSel
	| newInst |
	newInst := (self on: aClass selector: aSel)  mareaInstall.
	^ newInst! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxy classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
doesNotUnderstand: aMessage
	self log: ' CompiledMethodProxy dnu: ', aMessage asString.
	^ oldMethod isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			self mareaUninstall.
			oldMethod perform: aMessage selector withArguments: aMessage arguments.
			]! !

!CompiledMethodProxy methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/19/2010 11:44'!
flushCache
	"This method should be implemented because otherwise there are errors."! !

!CompiledMethodProxy methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/18/2010 10:53'!
initialize

	super initialize.
	executed := false! !

!CompiledMethodProxy methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/18/2010 10:46'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaExecuted
	^ executed! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaExecuted: anObject
	executed := anObject! !

!CompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/22/2010 17:03'!
mareaInstall
	[oldMethod := self mareaWrappedClass lookupSelector: self mareaSelector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod mareaUninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self log: 'The method ', self mareaSelector asString, ' is being wrapped'.
	self mareaWrappedClass methodDict at: self mareaSelector put: self! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaOldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
mareaOldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:21'!
mareaReference
	^ reference ! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 17:02'!
mareaSelector
	"Answer the value of selector"

	^ reference selector! !

!CompiledMethodProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/22/2010 17:14'!
mareaUninstall
	oldMethod isNil ifTrue: [^self].
	self mareaWrappedClass methodDict at: self mareaSelector put: oldMethod  

! !

!CompiledMethodProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 16:22'!
mareaWrappedClass
	"Answer the value of wrappedClass"

	^ reference actualClass! !

!CompiledMethodProxy methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 10/22/2010 16:20'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	self log: 'The method ', aSelector asString, ' is being executed'.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self mareaExecuted: true.
	self log: 'The method', aSelector asString, ' was executed'.
	self mareaUninstall.
	self log: 'The method proxy was uninstalled'.
	^aResult
	! !

ProtoObject subclass: #CompiledMethodProxyReferenceStream
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 16:17'!
installOn: aClass selector: aSel
	^ (self on: aClass selector: aSel)! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 16:11'!
on: aMethodReference
	^self new mareaInstallFor: aMethodReference ! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e mareaUninstall]].! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyReferenceStream classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/18/2010 15:07'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!CompiledMethodProxyReferenceStream methodsFor: 'catching' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
doesNotUnderstand: aMessage
	| oldMethod answer |
	self log: 'CompiledMethodProxyReferenceStream dnu: ', aMessage selector.
	^ fileName isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			oldMethod := self mareaUninstall.
			self log: 'The message will be sent to the original object'.
			answer := oldMethod perform: aMessage selector withArguments: aMessage arguments.
			self log: 'The message was sent to the original object'.
			^ answer.
			]
		! !

!CompiledMethodProxyReferenceStream methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 11:10'!
flushCache
	"Tell the interpreter to remove all references to this method from its method lookup cache, if it has one.  This primitive must be called whenever a method is defined or removed.
	NOTE:  Only one of two selective flush methods needs to be used.
	Squeak 2.2 and earlier uses 119 (See Symbol flushCache).
	Squeak 2.3 and later uses 116 (See CompiledMethod flushCache)."

	<primitive: 116>
! !

!CompiledMethodProxyReferenceStream methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
mareaInstallFor: aMethodReference
	| oldMethod oldClass selector |
	oldClass := aMethodReference actualClass. 
	selector := aMethodReference  selector. 
	[oldMethod := oldClass lookupSelector: selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod mareaUninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self log: 'The method ', selector asString, ' is being wrapped'.
	fileName := self mareaWriteMethodOnDisk: oldMethod.
	oldClass methodDict at: selector put: self.
	! !

!CompiledMethodProxyReferenceStream methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:13'!
mareaLoadCompiledMethodFrom: aFileName
	| refStream aCompiledMethod |
	refStream := ReferenceStream fileNamed: fileName.
	aCompiledMethod := refStream next.
	refStream close.
	^ aCompiledMethod! !

!CompiledMethodProxyReferenceStream methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 10/22/2010 16:13'!
mareaUninstall
	| oldMethod |
	fileName isNil ifTrue: [^self].
	oldMethod := self mareaLoadCompiledMethodFrom: fileName.
	self log: 'The CompiledMethod ', oldMethod selector, ' was loaded form file.'.
	oldMethod methodClass  methodDict at: (oldMethod selector) put: oldMethod.
	self log: 'The Proxy for ', oldMethod selector, ' was uninstalled.'.
	^ oldMethod.  

! !

!CompiledMethodProxyReferenceStream methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
mareaWriteMethodOnDisk: aCompiledMethod
	| refStream aFileName | 
	aFileName := String streamContents: [ :stream | aCompiledMethod printOn: stream ].
	refStream := ReferenceStream fileNamed: aFileName.
	refStream nextPut: aCompiledMethod.
	refStream close.
	self log: 'The method ', aCompiledMethod selector asString, ' was written on file'.
	^ aFileName 
	! !

!CompiledMethodProxyReferenceStream methodsFor: 'evaluation' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
run: aSelector with: arguments in: aReceiver

	| aResult oldMethod |
	self log: 'The method ', aSelector, ' is being executed'.
	oldMethod := self mareaUninstall.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self log: 'The method ', aSelector, ' was executed'.
	^aResult
	! !

ProtoObject subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy methodsFor: 'proxy' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
become: anObject
	self mareaSerializeAndWriteToDisk: anObject.
	"anObject becomeForward: self. "
	super become: anObject. ! !

!ObjectProxy methodsFor: 'catching' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
doesNotUnderstand: aMessage
	self log: 'Message not understood:', aMessage asString.
	self log: 'Will restore object'.
	self become: self mareaLoadBackSerializedObjectsFromFile.
	self log: 'Object was restored'.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaLoadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

!ObjectProxy methodsFor: 'swapping' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject	
	| file result |
	fileName := (DateAndTime now asString, '.swap').
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Proxies' stamp: 'MarianoMartinezPeck 10/20/2010 15:17'!
log: anObject
	ProxiesLogger logger log: anObject.! !

Object subclass: #ClassProxyFileOut
	instanceVariableNames: 'superclass methodDict format className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/17/2010 17:02'!
become: aClass
	| classNameBkp |
	className := aClass name.
	"FileDirectory default  deleteFileNamed: aClass name, '.st'  ifAbsent: [].
	"aClass fileOut.
	"Smalltalk removeClassNamed: className.
	"
	super become: aClass
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:49'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:52'!
fileInClass.
	(FileStream fileNamed: className, '.st') fileIn.
	^ Smalltalk at: className. 
	! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:50'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/20/2010 15:55'!
restore
	self log: 'Will restore class'.
	super become: self fileInClass.
	self log: 'Class restored'.
! !

Object subclass: #CompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:12'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	UnusedObjectDiscoverer current startDiscovery. 
	
	aProxy := CompiledMethodProxyReferenceStream installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	aProxy mareaUninstall.
	
	aProxy := CompiledMethodProxyReferenceStream installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.
	aProxy mareaUninstall.
	
	UnusedObjectDiscoverer current stopDiscovery.
	^ CompiledMethod usedInstances.! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/19/2010 19:06'!
nose 
	| minimalCompiledMethods |
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
	(PackageInfo named: 'SUnitGUI') classes do: [:aClass|
		aClass allMethods do: [ :aMethod |
			CompiledMethodProxyReferenceStream installOn: aClass selector: aMethod selector.
			]. 
		].
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
! !

!CompiledMethodSwapper classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/19/2010 20:02'!
nose2 
	| minimalCompiledMethods |
	minimalCompiledMethods := self discoverMinimalUsedCompiledMethods.
	TestRunner methods do: [ :aMethod |
			CompiledMethodProxyReferenceStream installOn: TestRunner selector: aMethod selector.
			]. 
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
! !

Object subclass: #ObjectSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/21/2010 18:26'!
fileName
	^ DateAndTime now asString , '.swap'! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
mareaSerializeAndWriteToDisk: anObject
	| file fileName result |
	fileName := self fileName.
	file := FileStream fileNamed: fileName.
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ fileName! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/22/2010 16:16'!
swap: anObject
	| fileName proxy |
	fileName := self mareaSerializeAndWriteToDisk: anObject. 
	
	"make this nicer"
	anObject isBehavior 
		ifTrue: [proxy := AClassProxy forFileName: fileName.]
		ifFalse: [proxy := ObjectProxy forFileName: fileName.].
	
	anObject becomeForward: proxy. ! !

Object subclass: #ProxiesLogger
	instanceVariableNames: ''
	classVariableNames: 'ProxiesLoggerHolder'
	poolDictionaries: ''
	category: 'Proxies'!

!ProxiesLogger classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/20/2010 15:27'!
changeToFileLogger
	"ProxiesLogger changeToFileLogger"
	^ self initialize! !

!ProxiesLogger classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/20/2010 15:25'!
changeToTranscriptLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!ProxiesLogger classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/20/2010 15:14'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'Proxies.txt'). 
	logger startLogging.
	^ logger! !

!ProxiesLogger classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/20/2010 15:28'!
disableLogging
	| logger |
	logger := SimpleLogger new.
	logger strategy: NullLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!ProxiesLogger classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2010 15:13'!
example
	MyAppLogger logger log: 'zaraza'
	"Actually the idae is that you can create a method *MyAppLogger in Object that does:
	log: anObject
		MyAppLogger logger log: anObject
	
	So after, everywhere in your app you can just do self log: 'something'.
	"
	! !

!ProxiesLogger classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 17:08'!
initialize 
	ProxiesLoggerHolder := self createLogger.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.! !

!ProxiesLogger classSide methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 15:15'!
logger
	ProxiesLoggerHolder
		ifNil: [ProxiesLoggerHolder := self createLogger].
	^ ProxiesLoggerHolder! !

!ProxiesLogger classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2010 17:07'!
shutDown
	self logger stopLogging.! !

!ProxiesLogger classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/20/2010 17:07'!
startUp
 	self logger startLogging.! !

Object subclass: #ProxySuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ProxySuperclass methodsFor: 'swapping' stamp: 'NouryBouraqadi 10/1/2010 15:08'!
cannotInterpret: aMessage
	Transcript cr; 
		show: 'cannotInterpret:';
		space;
		show: aMessage selector..
	self class restore.
	^aMessage sendTo: self! !
ProxiesLogger initialize!
